//
//  pngwithwebp.m
//  pngwithwebp
//
//  Created by wangzhaoqiang on 2019/11/10.
//  Copyright © 2019 wangzhaoqiang. All rights reserved.
//

#import "pngwithwebp.h"
#import "iCore.h"
#import <WebPDecoder/decode.h>

@implementation UIImage(WebP)

static void free_image_data(void *info, const void *data, size_t size) {
    free((void*) data);
}

-(void)Initialize:(B4I*)bi :(NSString *)EventName {
    [B4IObjectWrapper setBIAndEventName:self :bi :EventName];
    
}
//- (UIImage*)imageWithWebp:(B4I *)bi :(NSURL*)fileURL {
 //   NSData *imageData = [NSData //dataWithContentsOfURL:fileURL];
    
 - (UIImage*)imageWithWebp:(B4I *)bi :(NSString*)filestring {
     
     NSURL *fileURL=[NSURL URLWithString:filestring];
     NSData *imageData = [NSData dataWithContentsOfURL:fileURL];
    
    
    
    int width = 0, height = 0;
    uint8_t* data = WebPDecodeRGBA(imageData.bytes, imageData.length, &width, &height);
    
    CGDataProviderRef provider = CGDataProviderCreateWithData(NULL, data, width * 4 * height, free_image_data);
    CGColorSpaceRef colorSpaceRef = CGColorSpaceCreateDeviceRGB();
    
    CGImageRef imageRef = CGImageCreate(width, height, 8, 32, 4 * width,
                                        colorSpaceRef, kCGBitmapByteOrderDefault, provider, NULL, NO, kCGRenderingIntentDefault);
    UIImage *result = [UIImage imageWithCGImage:imageRef];
    
    CGImageRelease(imageRef);
    CGColorSpaceRelease(colorSpaceRef);
    CGDataProviderRelease(provider);
    
    return result;
}
@end
